VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "xIcon Browser"
   ClientHeight    =   2400
   ClientLeft      =   2685
   ClientTop       =   2235
   ClientWidth     =   6030
   Icon            =   "frmMain.frx":0000
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   160
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   402
   ShowInTaskbar   =   0   'False
   Tag             =   "101"
   Begin VB.VScrollBar scrlOffset 
      Height          =   1995
      LargeChange     =   128
      Left            =   4230
      Max             =   3390
      SmallChange     =   16
      TabIndex        =   2
      Top             =   225
      Width           =   240
   End
   Begin VB.PictureBox picArea 
      Height          =   1995
      Left            =   270
      ScaleHeight     =   129
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   256
      TabIndex        =   1
      Top             =   225
      Width           =   3900
      Begin VB.Shape shBox 
         DrawMode        =   6  'Mask Pen Not
         Height          =   330
         Left            =   1890
         Top             =   450
         Visible         =   0   'False
         Width           =   285
      End
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   510
      Left            =   4635
      TabIndex        =   0
      Tag             =   "103"
      Top             =   1530
      Width           =   1230
   End
   Begin VB.Image imLarge 
      Height          =   480
      Left            =   5175
      Stretch         =   -1  'True
      Top             =   720
      Width           =   480
   End
   Begin VB.Image imSmall 
      Height          =   240
      Left            =   4725
      Top             =   855
      Width           =   240
   End
   Begin VB.Label lblIndex 
      AutoSize        =   -1  'True
      Caption         =   "Index: 0"
      Height          =   195
      Left            =   4680
      TabIndex        =   3
      Tag             =   "102"
      Top             =   315
      Width           =   570
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Connect As Connect
Private mbTmp As CommandBarButton
Private mCurrent As Long

Private Sub cmdClose_Click()
    Me.Hide
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Cancel = (UnloadMode = vbFormControlMenu)
    If Cancel Then cmdClose_Click
End Sub

Public Sub Run()
    On Error Resume Next
'    Dim idx As Long
'    Dim objImage As StdPicture
    
    Set mbTmp = Connect.VBInstance.CommandBars("Standard").Controls.Add(msoControlButton)
    If mbTmp Is Nothing Then
        MsgBox "Error adding button to standard command bar."
    Else
        mbTmp.Visible = False
        lblIndex.Caption = LoadResString(lblIndex.Tag) & " 0"
        Me.Show vbModal
'        For idx = scrlOffset.Min To scrlOffset.Max
'            mbTmp.FaceId = idx
'            mbTmp.CopyFace
'            DoEvents
'            Set objImage = Clipboard.GetData(ClipBoardConstants.vbCFBitmap)
'            SavePicture objImage, "d:\xxx\" & Trim$(Str$(idx)) & ".bmp"
'        Next
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    mbTmp.Delete
    Set mbTmp = Nothing
    Set Connect = Nothing
End Sub

Private Sub picArea_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim Row As Long, Col As Long
    
    If X < 0 Then Exit Sub
    If X > picArea.ScaleWidth Then Exit Sub
    If Y < 0 Then Exit Sub
    If Y > picArea.ScaleHeight Then Exit Sub
    
    Select Case Button
        Case vbLeftButton
            ' calc what icon clicked
            Row = Abs(Y \ 16) + 1
            Col = Abs(X \ 16) + 1
            
            mCurrent = ((Row - 1) * 16) + Col
            mCurrent = mCurrent + scrlOffset.Value
            lblIndex.Caption = LoadResString(lblIndex.Tag) & " " & mCurrent - 1
            shBox.Move Abs(X \ 16) * 16, Abs(Y \ 16) * 16, 16, 16
            shBox.Visible = True
            mbTmp.FaceId = mCurrent - 1
            mbTmp.CopyFace
            Set imSmall.Picture = Clipboard.GetData
            Set imLarge.Picture = imSmall.Picture
    End Select
End Sub

Private Sub picArea_Paint()
    Dim idx As Long, idy As Long
    Dim xPos As Long, yPos As Long
    Dim Index As Long
    
    
    On Error GoTo AnError
    
    picArea.Cls
    xPos = 0: yPos = 0
    Index = scrlOffset.Value
    For idy = 0 To 7
        For idx = 0 To 15
            mbTmp.FaceId = Index
            mbTmp.CopyFace
            
            picArea.PaintPicture Clipboard.GetData, xPos, yPos
                    
            Index = Index + 1
            xPos = xPos + 16
        Next
        xPos = 0
        yPos = yPos + 16
    Next
    
    Exit Sub

AnError:
    MsgBox "err " & Index
End Sub

Private Sub scrlOffset_Change()
    mCurrent = 0
    lblIndex.Caption = LoadResString(lblIndex.Tag) & " " & mCurrent

    shBox.Visible = False
    Set imSmall.Picture = Nothing
    Set imLarge.Picture = Nothing
    picArea.Refresh
End Sub

Private Sub scrlOffset_Scroll()
    scrlOffset_Change
End Sub
